code	segment	'CODE'
	assume	cs:code, ds:code

stksz	equ	512			; stack size in bytes
newsp	equ	cend+stksz-2		; new stack pointer
mempg	equ	newsp/16+1		; required paragraphs of memory

	org	100h			; COM model entry point

start:	cli				; set new stack pointer
	mov	sp,newsp
	sti

	mov	bx,mempg		; resize memory block to required
	mov	ah,4ah
	int	21h

	mov	ax,3521h		; address of previous INT 21 handler
	int	21h
	mov	word ptr [old21+1],bx
	mov	word ptr [old21+3],es

	mov	dx,offset new21		; install the watchdog handler
	mov	ax,2521h
	int	21h

	mov	[tseg],cs		; set segments in parameter block
	mov	[fcb1],cs
	mov	[fcb2],cs

	mov	[sseg],ss		; save the stack location
	mov	[spnt],sp

	mov     bx,offset parm		; EXEC the child program
	mov     dx,offset prog
	mov     ax,4b00h
	int     21h

	cli				; restore stack (for old DOS 2.x bug)
	mov	ss,[sseg]	
	mov	sp,[spnt]
	sti

	pushf				; save flags from EXEC

	mov	dx,word ptr [old21+1]	; restore previous INT 21 handler
	mov	ds,word ptr [old21+3]
	mov	ax,2521h
	int	21h
	push	cs			; restore data segment
	pop	ds

	popf				; restore flags
	jnc	noerr			; check if EXEC failed

	mov	dx,offset emsg		; display EXEC failure message
	mov	ah,09h
	int	21h
	xor	al,al			; no return code
	jmp	exit
	
noerr:	mov	ah,4dh			; get return code (errorlevel)
	int	21h

exit:	mov	ah,4ch			; exit to DOS with child's return code
	int	21h

;------ watchdog handler for INT 21/4E

new21:	cmp	ah,4eh			; check for DOS FindFirst function
	jne	old21			; pass along to previous handler if not

	push	ax			; save registers used on stack
	push	cx
	push	si

	mov	si,dx			; search filespec at DS:DX
	mov	cx,255			; maximum length to search
	cld

cloop:	lodsb
	cmp	al,'.'			; look for start of extension
	jne	term

ext:	lodsw				; check if extension is "XTI*"
	cmp	ax,'TX'
	jne	done
	lodsw
	cmp	ax,'*I'
	jne	done

	pop	si			; restore registers
	pop	cx
	pop	ax
	mov	ax,3			; indicate a DOS error 3, invalid path
	stc
	retf	2

term:	cmp	al,0			; drop out at terminator or max length
	loopne	cloop

done:	pop	si			; restore registers
	pop	cx
	pop	ax

old21:	
	db	0eah			; opcode for far jump
	dd	0			; address of previous INT 21 handler

;------------------- Parameter Block
parm	dw	0			; default environment segment

	dw	80h			; copied command line
tseg	dw	0

	dw	5ch			; copied 1st FCB
fcb1	dw	0

	dw	6ch			; copied 2nd FCB
fcb2	dw	0
;-------------------

sseg	dw	0
spnt	dw	0

prog	db	'BWAVE.EXE',0

emsg	db	'Error executing Blue Wave...',0dh,0ah,'$'

cend	equ	$

code	ends

	end	start
